# Player Game List GET /api/v1/problems/player-game/ Reference: https://docs.aisquare.studio/api-reference/ai-square-studio-api/problems/player-game-list ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: AISquare Studio API version: 1.0.0 paths: /api/v1/problems/player-game/: get: operationId: player-game-list summary: Player Game List tags: - subpackage_problems parameters: - name: created_at__gte in: query required: false schema: type: string format: date-time - name: created_at__lte in: query required: false schema: type: string format: date-time - name: creator in: query required: false schema: type: integer - name: is_completed in: query required: false schema: type: boolean - name: is_loaded in: query required: false schema: type: boolean - name: is_started in: query required: false schema: type: boolean - name: page in: query description: A page number within the paginated result set. required: false schema: type: integer - name: page_size in: query description: Number of results to return per page. required: false schema: type: integer responses: '200': description: '' content: application/json: schema: $ref: '#/components/schemas/PaginatedPlayerGameList' components: schemas: UserSimple: type: object properties: id: type: integer username: type: string description: >- Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. email: type: string format: email full_name: type: string first_time_login: type: boolean description: Check if this is the user's first login. theme: type: - string - 'null' is_superuser: type: boolean description: >- Designates that this user has all permissions without explicitly assigning them. is_staff: type: boolean description: Designates whether the user can log into this admin site. is_active: type: boolean description: >- Designates whether this user should be treated as active. Unselect this instead of deleting accounts. is_verified: type: boolean profile_picture: type: string format: uri description: |- Convert ImageFieldFile to URL string for JSON serialization. Args: obj: The model instance being serialized (typically IAMUser) Returns: str | None: The URL of the profile picture, or None if not available required: - id - username - email - first_time_login - profile_picture description: >- Mixin to handle profile_picture serialization for WebSocket compatibility. This mixin adds a SerializerMethodField for profile_picture that converts ImageFieldFile objects to URL strings, making them JSON serializable for WebSocket consumers. The mixin intelligently handles profile pictures from IAMUserDetail by: 1. Accessing the related `details` queryset on the IAMUser model 2. Extracting the ImageFieldFile from the first detail record 3. Converting it to a URL string for JSON serialization Usage: ```python class MyUserSerializer(ProfilePictureMixin, serializers.ModelSerializer): class Meta: model = User fields = ['id', 'username', 'profile_picture', ...] ``` Note: - This mixin expects the model to have a `details` related manager - The related detail should have a `profile_picture` ImageField - Returns None if no profile picture is found or an error occurs title: UserSimple PlayerQuestElo: type: object properties: quest_id: type: string format: uuid quest_name: type: string elo: type: integer required: - quest_id - quest_name description: Serializer for quest-specific ELO ratings title: PlayerQuestElo Player: type: object properties: id: type: integer user: $ref: '#/components/schemas/UserSimple' quest_elos: type: array items: $ref: '#/components/schemas/PlayerQuestElo' uid: type: string format: uuid created_at: type: string format: date-time updated_at: type: string format: date-time deleted_at: type: - string - 'null' format: date-time is_active: type: boolean created_by: type: - string - 'null' updated_by: type: - string - 'null' deleted_by: type: - string - 'null' last_online_at: type: - integer - 'null' format: int64 is_in_game: type: boolean experience: type: integer experience_level: type: integer experience_updated_at: type: string format: date-time in_game: type: - integer - 'null' required: - id - user - quest_elos - uid - created_at - updated_at - experience_updated_at title: Player InviteStatusEnum: type: string enum: - '0' - '1' - '2' description: |- * `0` - Rejected * `1` - Invited * `2` - Accepted title: InviteStatusEnum PlayerGamePlayer: type: object properties: id: type: integer player: $ref: '#/components/schemas/Player' score: type: integer elo_delta: type: integer quest_elo_delta: description: Any type invite_status: $ref: '#/components/schemas/InviteStatusEnum' answered_questions_count: type: integer description: >- Returns the number of questions answered by this player in this game. correct_answers_count: type: integer description: >- Returns the number of questions answered correctly by this player in this game. is_following: type: boolean description: Whether the requesting user follows this player required: - id - player - invite_status - answered_questions_count - correct_answers_count - is_following title: PlayerGamePlayer PlayerMinimal: type: object properties: id: type: integer user: $ref: '#/components/schemas/UserSimple' uid: type: string format: uuid last_online_at: type: - integer - 'null' format: int64 online_status: type: string experience: type: integer experience_level: type: integer required: - id - user - uid - online_status title: PlayerMinimal PlayerGame: type: object properties: id: type: integer player_game_players: type: array items: $ref: '#/components/schemas/PlayerGamePlayer' primary_quest: type: string format: uuid subtopics: type: string description: Free-text field for quest subtopics progress: type: string correct_problems: type: integer answered_problems: type: integer total_points: type: integer status: type: string name: type: string problems_loading_progress: type: number format: double description: >- Returns the percentage of problems loaded during game initialization. Only returns 100% when is_loaded=True, otherwise caps at 99%. Returns: float: Percentage of problems loaded (0.0 to 100.0) players_progress_summary: type: string problem_tiles: type: array items: description: Any type players: type: array items: type: integer winner: $ref: '#/components/schemas/PlayerMinimal' creator: $ref: '#/components/schemas/PlayerMinimal' is_creator: type: boolean uid: type: string format: uuid created_at: type: string format: date-time updated_at: type: string format: date-time deleted_at: type: - string - 'null' format: date-time is_active: type: boolean created_by: type: - string - 'null' updated_by: type: - string - 'null' deleted_by: type: - string - 'null' cfg_number_of_problems: type: integer cfg_time_limit_seconds: type: integer cfg_elo_level: type: integer elo_delta: type: integer quest_elo_deltas: description: Any type is_started: type: boolean is_completed: type: boolean is_loaded: type: boolean completed_at: type: - string - 'null' format: date-time required: - id - player_game_players - progress - correct_problems - answered_problems - total_points - status - name - problems_loading_progress - players_progress_summary - problem_tiles - winner - is_creator - uid - created_at - updated_at - elo_delta - quest_elo_deltas - is_completed title: PlayerGame PaginatedPlayerGameList: type: object properties: count: type: integer next: type: - string - 'null' format: uri previous: type: - string - 'null' format: uri results: type: array items: $ref: '#/components/schemas/PlayerGame' required: - count - results title: PaginatedPlayerGameList ``` ## SDK Code Examples ```python import requests url = "https://api.example.com/api/v1/problems/player-game/" payload = {} headers = {"Content-Type": "application/json"} response = requests.get(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/problems/player-game/'; const options = {method: 'GET', headers: {'Content-Type': 'application/json'}, body: '{}'}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/problems/player-game/" payload := strings.NewReader("{}") req, _ := http.NewRequest("GET", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/problems/player-game/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.example.com/api/v1/problems/player-game/") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('GET', 'https://api.example.com/api/v1/problems/player-game/', [ 'body' => '{}', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/problems/player-game/"); var request = new RestRequest(Method.GET); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/problems/player-game/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```